#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=ClipboardMemo.ico
#AutoIt3Wrapper_Outfile=ClipboardMemo.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=ClipboardMemo
#AutoIt3Wrapper_Res_Fileversion=2.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <ButtonConstants.au3>
#include <Clipboard.au3>
#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <GuiStatusBar.au3>
#include <Math.au3>
#include <Misc.au3>
#include <SendMessage.au3>
#include <StatusBarConstants.au3>
#include <WindowsConstants.au3>

Opt('GUIOnEventMode', 1)
Opt('TrayMenuMode', 1)
Opt('TrayOnEventMode', 1)
Opt('GUICloseOnESC', 0)

Global $sTitle = 'Clipboard Memo v2.1'
If _Singleton($sTitle, 1) = 0 Then Exit MsgBox(64, $sTitle, 'An occurence of ' & $sTitle & ' is already running')

Global $sScriptDir = @ScriptDir
If StringRight($sScriptDir, 1) <> '\' Then $sScriptDir &= '\'

Global $sIconfile = $sScriptDir & 'icons.dll'
If Not FileExists($sIconfile) Then Exit MsgBox(16, $sTitle, 'The File "icons.dll" was not found.')

Global $sAutoSavefile = $sScriptDir & 'autosave.txt'

Global $sInifile = $sScriptDir & 'ClipboardMemo.ini'
Global $iGuiWidth = IniRead($sInifile, 'Size', 'Width', 330)
Global $iGuiHeight = IniRead($sInifile, 'Size', 'Height', 400)
Global $iGuiPosX = IniRead($sInifile, 'Pos', 'X', @DesktopWidth / 2 - $iGuiWidth / 2)
Global $iGuiPosY = IniRead($sInifile, 'Pos', 'Y', @DesktopHeight / 2 - $iGuiHeight / 2)
Global $sDefaultFolder = IniRead($sInifile, 'Select', 'Dest-Folder', '')
Global $bCopyOW = Execute(IniRead($sInifile, 'Settings', 'CopyOverwrite', False))
Global $bAutostart = Execute(IniRead($sInifile, 'Settings', 'Autostart', False))

;~ Global Const $WS_EX_COMPOSITED = 0x02000000
Global $hGUI = GUICreate($sTitle, $iGuiWidth, $iGuiHeight, $iGuiPosX, $iGuiPosY, BitOR($GUI_SS_DEFAULT_GUI, $WS_MAXIMIZEBOX, $WS_SIZEBOX), $WS_EX_COMPOSITED)
GUISetOnEvent($GUI_EVENT_CLOSE, '_MinimizeToTray')
GUISetIcon($sIconfile, 10, $hGUI)

GUICtrlCreateIcon($sIconfile, 1, 6, 6, 48, 48)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)
Global $hClear = GUICtrlCreateButton('&Clear Edit', 2, 2, 56, 70, BitOR($WS_CLIPSIBLINGS, $BS_BOTTOM))
GUICtrlSetOnEvent(-1, '_Clear')
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)

GUICtrlCreateIcon($sIconfile, 2, 70, 6, 48, 48)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)
Global $hSave = GUICtrlCreateButton('&Save As...', 66, 2, 56, 70, BitOR($WS_CLIPSIBLINGS, $BS_BOTTOM))
GUICtrlSetOnEvent(-1, '_Save')
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)

Global $hCopyIcon = GUICtrlCreateIcon($sIconfile, 3, 134, 6, 48, 48)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)
Global $hCopy = GUICtrlCreateButton('Copy &Files', 130, 2, 56, 70, BitOR($WS_CLIPSIBLINGS, $BS_BOTTOM))
GUICtrlSetOnEvent(-1, '_Copy')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)

GUICtrlCreateIcon($sIconfile, 5, 198, 6, 48, 48)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)
Global $hBack = GUICtrlCreateButton('Edit&ToClip', 194, 2, 56, 70, BitOR($WS_CLIPSIBLINGS, $BS_BOTTOM))
GUICtrlSetOnEvent(-1, '_Back')
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)

GUICtrlCreateIcon($sIconfile, 6, 262, 6, 48, 48)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)
Global $hInfo = GUICtrlCreateButton('&Info', 258, 2, 56, 70, BitOR($WS_CLIPSIBLINGS, $BS_BOTTOM))
GUICtrlSetOnEvent(-1, '_Info')
GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKLEFT + $GUI_DOCKTOP)

Global $hMemo = GUICtrlCreateEdit('', 2, 75, $iGuiWidth - 4, $iGuiHeight - 100, $WS_VSCROLL)
GUICtrlSetFont(-1, 10, 400, 0, 'Courier New')
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKBOTTOM)
If FileExists($sAutoSavefile) Then GUICtrlSetData(-1, FileRead($sAutoSavefile))

Global $hStatus = _GUICtrlStatusBar_Create($hGUI)
_GUICtrlStatusBar_SetText($hStatus, 'Ready.')

TraySetClick(8)
TraySetIcon($sIconfile, 10)
TraySetToolTip($sTitle)
TraySetOnEvent($TRAY_EVENT_PRIMARYDOUBLE, '_Restore')
TrayCreateItem($sTitle)
TrayItemSetOnEvent(-1, '_Info')
TrayCreateItem('')
Global $hSettings = TrayCreateMenu('Settings')
Global $hTrayCopyOW = TrayCreateItem('Copy overwrite on', $hSettings)
TrayItemSetOnEvent(-1, '_CopyOW')
If $bCopyOW Then
	TrayItemSetState(-1, $TRAY_CHECKED)
Else
	TrayItemSetState(-1, $TRAY_UNCHECKED)
EndIf
Global $hTrayAutoSt = TrayCreateItem('Start with Windows', $hSettings)
TrayItemSetOnEvent(-1, '_Autostart')
If $bAutostart Then
	TrayItemSetState(-1, $TRAY_CHECKED)
	If @Compiled Then FileCreateShortcut(@ScriptFullPath, @StartupDir & '\' & @ScriptName)
Else
	TrayItemSetState(-1, $TRAY_UNCHECKED)
	If @Compiled Then FileDelete(@StartupDir & '\' & @ScriptName & '.lnk') ; Verknpfung lschen
EndIf
Global $hTrayMinimize = TrayCreateItem('Minimize To Tray')
TrayItemSetOnEvent(-1, '_MinimizeToTray')
TrayCreateItem('')
TrayCreateItem('Exit')
TrayItemSetOnEvent(-1, '_End')

If $bAutostart Then
	_MinimizeToTray()
Else
	GUISetState()
EndIf

ControlFocus($hGUI, '', $hMemo)
WinSetOnTop($hGUI, '', 1)
Global $hNext = _ClipBoard_SetViewer($hGUI)

Global Const $Range = 40
Global $x_start, $y_start
GUIRegisterMsg($WM_ENTERSIZEMOVE, 'WM_ENTERSIZEMOVE')
GUIRegisterMsg($WM_MOVING, 'WM_MOVING')

GUIRegisterMsg($WM_CHANGECBCHAIN, 'WM_CHANGECBCHAIN')
GUIRegisterMsg($WM_DRAWCLIPBOARD, 'WM_DRAWCLIPBOARD')
GUIRegisterMsg($WM_GETMINMAXINFO, 'WM_GETMINMAXINFO')
GUIRegisterMsg($WM_MOVE, 'WM_MOVE')
GUIRegisterMsg($WM_SIZE, 'WM_SIZE')

HotKeySet('!x', '_MinimizeToTray')
HotKeySet('!e', '_End')

Global $aClipboard
While True
	$aClipboard = StringRegExp(GUICtrlRead($hMemo), '(?i)(\\\\.*|[a-z]:\\.*)\r', 3)
	If IsArray($aClipboard) Then
		GUICtrlSetImage($hCopyIcon, $sIconfile, 4)
		GUICtrlSetState($hCopy, $GUI_ENABLE)
	Else
		GUICtrlSetImage($hCopyIcon, $sIconfile, 3)
		GUICtrlSetState($hCopy, $GUI_DISABLE)
	EndIf
	Sleep(100)
WEnd

Func _End()
	_ClipBoard_ChangeChain($hGUI, $hNext)
	Exit
EndFunc   ;==>_End

Func _AutoSave()
	Local $hFile = FileOpen($sAutoSavefile, 2)
	If $hFile <> -1 Then
		FileWrite($hFile, GUICtrlRead($hMemo))
		FileClose($hFile)
	EndIf
EndFunc   ;==>_AutoSave

Func _MinimizeToTray()
	HotKeySet('!x', '_Restore')
	TrayItemSetText($hTrayMinimize, 'Restore')
	TrayItemSetOnEvent($hTrayMinimize, '_Restore')
	GUISetState(@SW_HIDE, $hGUI)
EndFunc   ;==>_MinimizeToTray

Func _Restore()
	HotKeySet('!x', '_MinimizeToTray')
	TrayItemSetText($hTrayMinimize, 'Minimize To Tray')
	TrayItemSetOnEvent($hTrayMinimize, '_MinimizeToTray')
	GUISetState(@SW_SHOW, $hGUI)
EndFunc   ;==>_Restore

Func _CopyOW()
	$bCopyOW = Not $bCopyOW
	IniWrite($sInifile, 'Settings', 'CopyOverwrite', $bCopyOW)
	If $bCopyOW Then
		TrayItemSetState($hTrayCopyOW, $TRAY_CHECKED)
	Else
		TrayItemSetState($hTrayCopyOW, $TRAY_UNCHECKED)
	EndIf
EndFunc   ;==>_CopyOW

Func _Autostart()
	$bAutostart = Not $bAutostart
	IniWrite($sInifile, 'Settings', 'Autostart', $bAutostart)
	If $bAutostart Then
		TrayItemSetState($hTrayAutoSt, $TRAY_CHECKED)
		If @Compiled Then FileCreateShortcut(@ScriptFullPath, @StartupDir & '\' & @ScriptName)
	Else
		TrayItemSetState($hTrayAutoSt, $TRAY_UNCHECKED)
		If @Compiled Then FileDelete(@StartupDir & '\' & @ScriptName & '.lnk')
	EndIf
EndFunc   ;==>_Autostart

Func _Clear()
	GUICtrlSetData($hMemo, '')
	ControlFocus($hGUI, '', $hMemo)
	_AutoSave()
	_GUICtrlStatusBar_SetText($hStatus, 'Ready.')
EndFunc   ;==>_Clear

Func _Copy()
	Local $filecount = 0, $dircount = 0, $subfolder
	Local $sFolder = FileSelectFolder('Select Destination-Folder', '', 7, $sDefaultFolder, $hGUI)
	If @error Then Return _GUICtrlStatusBar_SetText($hStatus, 'Ready.')
	If StringRight($sFolder, 1) <> '\' Then $sFolder &= '\'
	IniWrite($sInifile, 'Select', 'Dest-Folder', $sFolder)
	$sDefaultFolder = $sFolder
	GUISetCursor(15, 1, $hGUI)
	For $i = 0 To UBound($aClipboard) - 1
		If FileExists($aClipboard[$i]) Then
			If StringInStr(FileGetAttrib($aClipboard[$i]), 'D', 2) Then
				_GUICtrlStatusBar_SetText($hStatus, 'Copy Directory! Please wait... (' & $aClipboard[$i] & ')')
				$subfolder = StringMid($aClipboard[$i], StringInStr($aClipboard[$i], '\', 2, -1) + 1)
				DirCopy($aClipboard[$i], $sFolder & $subfolder, $bCopyOW)
				$dircount += 1
			Else
				_GUICtrlStatusBar_SetText($hStatus, 'Copy File! Please wait... (' & $aClipboard[$i] & ')')
				FileCopy($aClipboard[$i], $sFolder, $bCopyOW)
				$filecount += 1
			EndIf
		EndIf
	Next
	GUISetCursor(2, 0, $hGUI)
	ControlFocus($hGUI, '', $hMemo)
	_GUICtrlStatusBar_SetText($hStatus, $filecount & ' File(s) and ' & $dircount & ' Directory(s) copied! Ready.')
EndFunc   ;==>_Copy

Func _Save()
	Local $sFile = FileSaveDialog($sTitle, $sScriptDir, 'All (*.*)', 16, 'CBMemo.txt', $hGUI)
	If @error Then Return
	Local $hFile = FileOpen($sFile, 2 + 8)
	If $hFile <> -1 Then
		FileWrite($hFile, GUICtrlRead($hMemo))
		FileClose($hFile)
		_GUICtrlStatusBar_SetText($hStatus, 'File saved! Ready.')
	Else
		_GUICtrlStatusBar_SetText($hStatus, 'Error! Cannot save file.')
	EndIf
	ControlFocus($hGUI, '', $hMemo)
EndFunc   ;==>_Save

Func _Back()
	Local $clip = GUICtrlRead($hMemo)
	GUICtrlSetData($hMemo, '')
	ClipPut($clip)
	ControlFocus($hGUI, '', $hMemo)
EndFunc   ;==>_Back

Func _Info()
	MsgBox(64 + 262144, $sTitle, 'Programmed at Dec 2008' & @CRLF & Chr(169) & ' by Oscar (www.autoit.de)')
	_GUICtrlStatusBar_SetText($hStatus, 'Ready.')
	ControlFocus($hGUI, '', $hMemo)
EndFunc   ;==>_Info

Func WM_MOVE($hWnd, $iMsg, $iwParam, $ilParam)
	Local $aWinPos = WinGetPos($hGUI)
	IniWrite($sInifile, 'Pos', 'X', $aWinPos[0])
	IniWrite($sInifile, 'Pos', 'Y', $aWinPos[1])
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_MOVE

Func WM_SIZE($hWnd, $iMsg, $iwParam, $ilParam)
	Local $aWinPos = WinGetPos($hGUI)
	$iGuiWidth = $aWinPos[2]
	$iGuiHeight = $aWinPos[3]
	IniWrite($sInifile, 'Size', 'Width', $aWinPos[2])
	IniWrite($sInifile, 'Size', 'Height', $aWinPos[3])
	_GUICtrlStatusBar_Resize($hStatus)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_SIZE

Func WM_CHANGECBCHAIN($hWnd, $iMsg, $iwParam, $ilParam)
	If $iwParam = $hNext Then
		$hNext = $ilParam
	ElseIf $hNext <> 0 Then
		_SendMessage($hNext, $WM_CHANGECBCHAIN, $iwParam, $ilParam, 0, 'hwnd', 'hwnd')
	EndIf
EndFunc   ;==>WM_CHANGECBCHAIN

Func WM_DRAWCLIPBOARD($hWnd, $iMsg, $iwParam, $ilParam)
	Local $clip = ClipGet()
	If @error Then Return
	$clip = StringRegExpReplace($clip, '(\S)(\n)', '$1' & @CRLF)
	If StringRight($clip, 2) <> @CRLF Then $clip &= @CRLF
	GUICtrlSetData($hMemo, GUICtrlRead($hMemo) & $clip)
	_AutoSave()
	_GUICtrlStatusBar_SetText($hStatus, 'Ready.', 0, $SBT_POPOUT)
	If $hNext <> 0 Then _SendMessage($hNext, $WM_DRAWCLIPBOARD, $iwParam, $ilParam)
EndFunc   ;==>WM_DRAWCLIPBOARD

Func WM_GETMINMAXINFO($hWnd, $msg, $wParam, $lParam)
	If $hWnd = $hGUI Then
		$minmaxinfo = DllStructCreate('int;int;int;int;int;int;int;int;int;int', $lParam)
		DllStructSetData($minmaxinfo, 7, 330) ; min X
		DllStructSetData($minmaxinfo, 8, 300) ; min Y
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_GETMINMAXINFO

Func WM_ENTERSIZEMOVE() ; Author: Xenobiologist (Mega)
	Local $aMPos = MouseGetPos()
	$x_start = $aMPos[0]
	$y_start = $aMPos[1]
EndFunc   ;==>WM_ENTERSIZEMOVE

Func WM_MOVING($hWnd, $msg, $wParam, $lParam) ; Author: Xenobiologist (Mega)
	Local $aMPos = MouseGetPos()
	Local $taskbarPos = WinGetPos('[CLASS:Shell_TrayWnd]')
	Local $rect = DllStructCreate('long left; long top; long right; long bottom', $lParam)
	Local $left = DllStructGetData($rect, 'left')
	Local $top = DllStructGetData($rect, 'top')
	Local $right = DllStructGetData($rect, 'right')
	Local $bottom = DllStructGetData($rect, 'bottom')
	If $left <= $Range And $aMPos[0] < $x_start Then
		DllStructSetData($rect, 'left', 0)
		DllStructSetData($rect, 'right', $right - $left)
	EndIf
	If $top <= $Range And $aMPos[1] < $y_start Then
		DllStructSetData($rect, 'top', 0)
		DllStructSetData($rect, 'bottom', $bottom - $top)
	EndIf
	If $right >= (@DesktopWidth - $Range) And $aMPos[0] > $x_start Then
		DllStructSetData($rect, 'right', @DesktopWidth)
		DllStructSetData($rect, 'left', (@DesktopWidth - $right) + $left)
	EndIf
	If $bottom >= ($taskbarPos[1] - $Range) And $aMPos[1] > $y_start Then
		DllStructSetData($rect, 'bottom', $taskbarPos[1])
		DllStructSetData($rect, 'top', ($taskbarPos[1] - $bottom) + $top)
	EndIf
	WM_ENTERSIZEMOVE()
EndFunc   ;==>WM_MOVING